import { Form } from '@genesislcap/foundation-forms';
import { html, ref, when } from '@microsoft/fast-element';
import { List } from '../list';
List;
Form;
/**
 * Defines the html of the entity component as a ViewTemplate object
 * @typeParam EntityManagement - the {@link EntityManagement | class} the template is defined for
 */
export const template = html `
  <div class="container">
    <entity-list
      title=${(x) => x.title}
      persist-column-state-key=${(x) => x.persistColumnStateKey}
      size-columns-to-fit=${(x) => x.sizeColumnsToFit}
      enable-filter-bar=${(x) => x.enableFilterBar}
      resourceName=${(x) => x.resourceName}
      :createEvent=${(x) => x.createEvent}
      :deleteEvent=${(x) => x.deleteEvent}
      :updateEvent=${(x) => x.updateEvent}
      :columns=${(x) => x.columns}
      :datasourceConfig=${(x) => x.datasourceConfig}
      data-test-id="entity-list"
    ></entity-list>
    <zero-modal
      ${ref('editEntityModal')}
      position="right"
      :onCloseCallback=${(x) => x.closeModal.bind(x)}
      data-test-id="edit-entity-modal"
    >
      <div slot="top" data-test-id="dialog-title">${(x) => x.editDialogTitle}</div>

      <slot name="edit">
        ${when((x) => x.editModalVisible, html `
            <foundation-form
              resourceName=${(x) => x.formResourceName}
              :data=${(x) => x.editedEntity}
              :uischema=${(x) => x.formUiSchema}
              @submit-success=${(x, c) => x.submitEntityChanges(c.event)}
            ></foundation-form>
          `)}
      </slot>
    </zero-modal>
  </div>
`;
